Bug 20959 - Style checkin form more like the checkout form, with collapsed settings panel
Summary: Style checkin form more like the checkout form, with collapsed settings panel
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Circulation (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Owen Leonard
QA Contact: Testopia
URL:
Keywords: Academy
: 14516 (view as bug list)
Depends on:
Blocks:
 
Reported: 2018-06-18 14:33 UTC by Owen Leonard
Modified: 2019-07-25 12:17 UTC (History)
11 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:
19.11.00


Attachments
Screenshot of the revised checkin form (9.86 KB, image/png)
2018-06-18 14:33 UTC, Owen Leonard
Details
Screenshot showing active book drop mode setting (11.26 KB, image/png)
2018-06-18 14:39 UTC, Owen Leonard
Details
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (22.02 KB, patch)
2018-06-18 15:11 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (22.08 KB, patch)
2018-06-27 15:27 UTC, Josef Moravec
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (22.36 KB, patch)
2018-06-29 12:45 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (follow-up) Prevent checkin button from wrapping (3.65 KB, patch)
2018-06-29 12:54 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (20.39 KB, patch)
2018-09-14 21:24 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (follow-up) Prevent checkin button from wrapping (3.67 KB, patch)
2018-09-14 21:24 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (20.94 KB, patch)
2018-09-14 22:34 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (follow-up) Prevent checkin button from wrapping (3.21 KB, patch)
2018-09-14 22:34 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (Follow-up) Keep informational notes open after checkin (2.67 KB, patch)
2018-09-14 23:11 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (21.00 KB, patch)
2018-09-14 23:30 UTC, Christopher Brannon
Details | Diff | Splinter Review
Bug 20959: (follow-up) Prevent checkin button from wrapping (3.27 KB, patch)
2018-09-14 23:30 UTC, Christopher Brannon
Details | Diff | Splinter Review
Bug 20959: (Follow-up) Keep informational notes open after checkin (2.73 KB, patch)
2018-09-14 23:30 UTC, Christopher Brannon
Details | Diff | Splinter Review
Bug 20959: (Follow-up) Keep informational notes open after checkin (2.71 KB, patch)
2018-10-01 18:22 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (21.51 KB, patch)
2018-12-07 19:20 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (follow-up) Prevent checkin button from wrapping (3.31 KB, patch)
2018-12-07 19:20 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (follow-up) Keep informational notes open after checkin (3.90 KB, patch)
2018-12-07 19:20 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Prevent the scrollbar to move to the top on click (3.23 KB, patch)
2018-12-13 19:29 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 20959: (follow-up) Alternate: Add preventDefault to link controls (1.45 KB, patch)
2019-01-10 16:36 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (20.77 KB, patch)
2019-03-11 17:59 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (20.87 KB, patch)
2019-03-18 18:44 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: (QA follow-up) Add missing $KohaDates filter (1.38 KB, patch)
2019-04-04 15:16 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (20.95 KB, patch)
2019-04-12 18:33 UTC, José-Mario Monteiro-Santos
Details | Diff | Splinter Review
Bug 20959: (QA follow-up) Add missing $KohaDates filter (1.46 KB, patch)
2019-04-12 18:34 UTC, José-Mario Monteiro-Santos
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (25.16 KB, patch)
2019-06-28 14:48 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (25.20 KB, patch)
2019-06-28 19:36 UTC, Arthur Bousquet
Details | Diff | Splinter Review
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel (25.22 KB, patch)
2019-07-01 20:32 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Owen Leonard 2018-06-18 14:33:53 UTC
Created attachment 76136 [details]
Screenshot of the revised checkin form

I think it would be nice to make the checkin page look more like the checkout page, with a collapsed panel where settings like book drop mode can be hidden when not in use.
Comment 1 Owen Leonard 2018-06-18 14:39:04 UTC
Created attachment 76137 [details]
Screenshot showing active book drop mode setting
Comment 2 Owen Leonard 2018-06-18 15:11:21 UTC Comment hidden (obsolete)
Comment 3 Josef Moravec 2018-06-27 15:27:15 UTC Comment hidden (obsolete)
Comment 4 Jonathan Druart 2018-06-27 19:33:55 UTC
I have the "Checkin" button at the bottom of the barcode input.

https://screenshots.firefox.com/FK6HtuCBLyx28NEA/pro.kohadev.org
Comment 5 Jonathan Druart 2018-06-28 16:11:09 UTC
Tomas tested on Ubuntu 18.04 + 1080p, with chrome, chromium and FF:

https://snag.gy/LGTqCl.jpg
Comment 6 Owen Leonard 2018-06-29 12:45:15 UTC Comment hidden (obsolete)
Comment 7 Owen Leonard 2018-06-29 12:54:04 UTC Comment hidden (obsolete)
Comment 8 Jonathan Druart 2018-06-29 13:39:36 UTC
Still not: https://screenshots.firefox.com/fqd4mfODVhwLxDXI/pro.kohadev.org
Comment 9 Jonathan Druart 2018-06-29 13:40:57 UTC
(In reply to Jonathan Druart from comment #8)
> Still not: https://screenshots.firefox.com/fqd4mfODVhwLxDXI/pro.kohadev.org

Well yes, it fixed the position of the button.
But now the messages on the right (settings) overlap the button.
Comment 10 Owen Leonard 2018-09-14 21:24:21 UTC Comment hidden (obsolete)
Comment 11 Owen Leonard 2018-09-14 21:24:25 UTC Comment hidden (obsolete)
Comment 12 Owen Leonard 2018-09-14 22:34:28 UTC Comment hidden (obsolete)
Comment 13 Owen Leonard 2018-09-14 22:34:33 UTC Comment hidden (obsolete)
Comment 14 Owen Leonard 2018-09-14 23:11:57 UTC Comment hidden (obsolete)
Comment 15 Christopher Brannon 2018-09-14 23:23:33 UTC
Display wise it works as described.  The layout looks fine on my end.

The only issue I have is that this changes past behavior, in that you have an extra step to open the options.  Typical upgrades try to maintain past behavior, and are changed by preference setting.  While I HATE having another preference setting, I know too many people are going to complain that they have to open that up every morning. This may be griped about more than the similar switch on the checkout page.

Perhaps, instead of a system preference, you do the same kind of setting similar to the checkbox on the checkouts TABLE that keeps the table open everytime you pull up the page.

The other thought is, why have a message displayed to the side, if when you have the feature active, it always shows?  Seems redundant.  Cool, but redundant.  The ONLY reason I would have the messages pinned to the side is if the feature settings were not glued to the page.  Make sense?
Comment 16 Christopher Brannon 2018-09-14 23:30:32 UTC Comment hidden (obsolete)
Comment 17 Christopher Brannon 2018-09-14 23:30:37 UTC Comment hidden (obsolete)
Comment 18 Christopher Brannon 2018-09-14 23:30:41 UTC Comment hidden (obsolete)
Comment 19 Christopher Brannon 2018-09-14 23:32:34 UTC
I signed off, as it works as described.  My concerns still apply.  Also, I don't know if it is consistent behavior prior to the patch, but why doesn't using the manual date option present a message up on the right like the checkboxes do?
Comment 20 Jonathan Druart 2018-09-16 21:19:25 UTC
In the last patch the following part reads wrong:

+                [% IF ( forgivemanualholdsexpire ) %]
+                    <div id="forgivemanualholdsexpire-alert" class="checkin-active-setting" style="display:none;">
+                [% ELSE %]
+                    <div id="forgivemanualholdsexpire-alert" class="checkin-active-setting" style="display:none;">
+                [% END %]
Comment 21 Owen Leonard 2018-10-01 18:22:05 UTC Comment hidden (obsolete)
Comment 22 Katrin Fischer 2018-10-06 19:59:49 UTC
Patch doesn't apply - Owen, can you please rebase?
Comment 23 Katrin Fischer 2018-10-06 20:00:44 UTC
CONFLICT (content): Merge conflict in koha-tmpl/intranet-tmpl/prog/en/modules/circ/returns.tt
Comment 24 Owen Leonard 2018-12-07 19:20:32 UTC Comment hidden (obsolete)
Comment 25 Owen Leonard 2018-12-07 19:20:37 UTC Comment hidden (obsolete)
Comment 26 Owen Leonard 2018-12-07 19:20:41 UTC Comment hidden (obsolete)
Comment 27 Jonathan Druart 2018-12-13 19:29:35 UTC Comment hidden (obsolete)
Comment 28 Jonathan Druart 2018-12-13 19:30:20 UTC
(In reply to Jonathan Druart from comment #27)
> Created attachment 83180 [details] [review] [review]
> Bug 20959: Prevent the scrollbar to move to the top on click

Hi Owen, can you give me your opinion on this patch? I can provide a follow-up to fix the :hover style if you think it is ok.
Comment 29 Owen Leonard 2019-01-10 16:36:31 UTC Comment hidden (obsolete)
Comment 30 Owen Leonard 2019-01-10 16:39:12 UTC
Sorry Jonathan I missed that you had added a follow-up to this. I've submitted an alternative which uses preventDefault. I don't think it makes sense to use the other solution just to make the link target wider. While a wider click target might be easier in some cases, I think it's usually better to make the click target match the controls so that clicking in "empty space" doesn't give unexpected results.
Comment 31 Jonathan Druart 2019-02-16 15:55:18 UTC
(In reply to Owen Leonard from comment #30)
> Sorry Jonathan I missed that you had added a follow-up to this. I've
> submitted an alternative which uses preventDefault. I don't think it makes
> sense to use the other solution just to make the link target wider. While a
> wider click target might be easier in some cases, I think it's usually
> better to make the click target match the controls so that clicking in
> "empty space" doesn't give unexpected results.

I always miss that link :) But I am ok with your solution if you disagree.
Comment 32 Katrin Fischer 2019-02-17 11:58:00 UTC
Rebase? :)
Comment 33 Owen Leonard 2019-03-11 17:59:25 UTC Comment hidden (obsolete)
Comment 34 Owen Leonard 2019-03-11 18:01:01 UTC
The rebase for this was tedious enough that I think it could use another look in the form of a signoff. Please?
Comment 35 Owen Leonard 2019-03-18 18:44:27 UTC Comment hidden (obsolete)
Comment 36 Katrin Fischer 2019-03-18 20:49:55 UTC
*** Bug 14516 has been marked as a duplicate of this bug. ***
Comment 37 Katrin Fischer 2019-04-03 22:42:23 UTC
Hi Owen, this looks nice!
Just something small: the effective checkin date for book drop mode shows in a strange format: 2019-04-02T22:40:10. Can you take a look?
Comment 38 Owen Leonard 2019-04-04 15:16:42 UTC Comment hidden (obsolete)
Comment 39 José-Mario Monteiro-Santos 2019-04-12 18:33:50 UTC Comment hidden (obsolete)
Comment 40 José-Mario Monteiro-Santos 2019-04-12 18:34:01 UTC Comment hidden (obsolete)
Comment 41 Séverine Queune 2019-04-16 12:56:17 UTC
Hi Owen,
Everything works fine, I've just got a question before signing this patch.
The only case the panel collapse is when I select a specific return date without checking the box "Remember for next check in".
That doesn't surprise me, but do you consider this is a correct behaviour ?
Comment 42 Owen Leonard 2019-06-28 14:48:18 UTC
Created attachment 91081 [details] [review]
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel

This patch modifies the structure of the checkin form so that settings
(Specify return date, book drop mode, forgive overdue charges) are in a
collapsed panel when inactive. The style of the barcode field and the
mode notification messages has been changed to reduce the vertical
motion of the form when selecting options.

Some class names have been changed in circulation.tt and circulation.js
to make them appropriate for use on both forms.

To test, apply the patch and rebuild the staff client CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).
Clear your browser cache if necessary.

 - View the checkin page. The "checkin settings" panel should be
   collapsed by default.
 - Confirm that the settings panel collapses and expands as it should.
 - Confirm that selecting "Forgive overdue charges" or "Book drop mode"
   trigger the display of the correct message and that the style of the
   barcode field is changed.
 - Confirm that after submitting a barcode for check-in, the
   settings panel stays open and your selected settings are still
   selected.
 - Confirm that specifying a due date and selecting "remember" shows
   a new message with the selected date.
   - Confirm that unchecking "remember" hides the message.
   - Confirm that date settings are remembered and the correct message
     displayed (or not) during check-in.
 - Test with CircSidebar enabled and disabled.
Comment 43 Arthur Bousquet 2019-06-28 19:36:27 UTC
Created attachment 91123 [details] [review]
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel

This patch modifies the structure of the checkin form so that settings
(Specify return date, book drop mode, forgive overdue charges) are in a
collapsed panel when inactive. The style of the barcode field and the
mode notification messages has been changed to reduce the vertical
motion of the form when selecting options.

Some class names have been changed in circulation.tt and circulation.js
to make them appropriate for use on both forms.

To test, apply the patch and rebuild the staff client CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).
Clear your browser cache if necessary.

 - View the checkin page. The "checkin settings" panel should be
   collapsed by default.
 - Confirm that the settings panel collapses and expands as it should.
 - Confirm that selecting "Forgive overdue charges" or "Book drop mode"
   trigger the display of the correct message and that the style of the
   barcode field is changed.
 - Confirm that after submitting a barcode for check-in, the
   settings panel stays open and your selected settings are still
   selected.
 - Confirm that specifying a due date and selecting "remember" shows
   a new message with the selected date.
   - Confirm that unchecking "remember" hides the message.
   - Confirm that date settings are remembered and the correct message
     displayed (or not) during check-in.
 - Test with CircSidebar enabled and disabled.

Signed-off-by: Arthur Bousquet <arthur.bousquet@inlibro.com>
Comment 44 Katrin Fischer 2019-07-01 20:26:30 UTC
This works well for me, just a spelling question:

Remember due date for next check in

Should it be check-in in this case? (substantive)?
Comment 45 Katrin Fischer 2019-07-01 20:32:59 UTC
Created attachment 91164 [details] [review]
Bug 20959: Style checkin form more like the checkout form, with collapsed settings panel

This patch modifies the structure of the checkin form so that settings
(Specify return date, book drop mode, forgive overdue charges) are in a
collapsed panel when inactive. The style of the barcode field and the
mode notification messages has been changed to reduce the vertical
motion of the form when selecting options.

Some class names have been changed in circulation.tt and circulation.js
to make them appropriate for use on both forms.

To test, apply the patch and rebuild the staff client CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).
Clear your browser cache if necessary.

 - View the checkin page. The "checkin settings" panel should be
   collapsed by default.
 - Confirm that the settings panel collapses and expands as it should.
 - Confirm that selecting "Forgive overdue charges" or "Book drop mode"
   trigger the display of the correct message and that the style of the
   barcode field is changed.
 - Confirm that after submitting a barcode for check-in, the
   settings panel stays open and your selected settings are still
   selected.
 - Confirm that specifying a due date and selecting "remember" shows
   a new message with the selected date.
   - Confirm that unchecking "remember" hides the message.
   - Confirm that date settings are remembered and the correct message
     displayed (or not) during check-in.
 - Test with CircSidebar enabled and disabled.

Signed-off-by: Arthur Bousquet <arthur.bousquet@inlibro.com>
Comment 46 Martin Renvoize 2019-07-02 08:21:24 UTC
Nice work!

Pushed to master for 19.11.00
Comment 47 Fridolin SOMERS 2019-07-25 12:17:50 UTC
Enhancement not pushed to 19.05.x

I prefer not change this display in stable branche